#!/usr/bin/perl -w

$top_dir="/usr/local/omsEnhanced/";
$htdocs_dir="/plmstats/";
$group_file="${top_dir}conf/grouplist.cfg";
$policy_dir='/etc/plm/policies/';
#@colors=("#FF0000", "#00FFFF", "#FFFF00", "#0000FF", "#00FF00", "#FF00FF");
#@colors=(
#"#289DD8", 
#"#5CCC34",
#"#E98F17",
#"#8D54E0",
#"#0D30DF",
#"#B37DCD",
#"#59D3A5");
@colors=(
"#289DD8", 
"#5CCC34",
"#98C9E2",
"#B37DCD",
"#0D30DF",
"#FF3401",
"#59D3A5");

sub get_cpu_load_high_low {
  local($group, $partition);
  
  $group = $_[0];
  $partition = $_[1];
  $cpu_load_high = 0;
  $cpu_load_low = 0;
  
  open(PLMIN, $policy_dir . $group);
  @polici_lines=<PLMIN>;
  foreach $policy_line (@polici_lines) {
    if ($policy_line =~ /$partition/) {
      $found = 1;
    } elsif ($policy_line =~ /^[a-z]/) {
      $found = 0;
    }
    
    if ($found eq 1) {
      if ($policy_line =~ /cpu_load_high/) {
        @temp_items = split(/=/, $policy_line);
        $cpu_load_high = @temp_items[1] / 1;
      }
      
      if ($policy_line =~ /cpu_load_low/) {
        @temp_items = split(/=/, $policy_line);
        $cpu_load_low = @temp_items[1] / 1;
      }
    }
  }
}


sub get_cpu_max_min {
  local($group, $partition);
  
  $group = $_[0];
  $partition = $_[1];
  $cpu_max = 0;
  $cpu_min = 0;
  
  open(PLMIN, $policy_dir . $group);
  @polici_lines=<PLMIN>;
  foreach $policy_line (@polici_lines) {
    if ($policy_line =~ /$partition/) {
      $found = 1;
    } elsif ($policy_line =~ /^[a-z]/) {
      $found = 0;
    }
    
    if ($found eq 1) {
      if ($policy_line =~ /cpu_maximum/) {
        @temp_items = split(/=/, $policy_line);
        $cpu_max = @temp_items[1] / 1;
      }
      
      if ($policy_line =~ /cpu_minimum/) {
        @temp_items = split(/=/, $policy_line);
        $cpu_min = @temp_items[1] / 1;
      }
    }
  }
}
