#!/usr/bin/perl

sub get_cpu_load_high_low {
  local($group, $partition);
  
  $group = $_[0];
  $partition = $_[1];
  $cpu_load_high = 0;
  $cpu_load_low = 0;
  
  open(PLMIN, $policy_dir . $group);
  @polici_lines=<PLMIN>;
  foreach $policy_line (@polici_lines) {
    if ($policy_line =~ /$partition/) {
      $found = 1;
    } elsif ($policy_line =~ /^[a-z]/) {
      $found = 0;
    }
    
    if ($found eq 1) {
      if ($policy_line =~ /cpu_load_high/) {
        @temp_items = split(/=/, $policy_line);
        $cpu_load_high = @temp_items[1] / 1;
      }
      
      if ($policy_line =~ /cpu_load_low/) {
        @temp_items = split(/=/, $policy_line);
        $cpu_load_low = @temp_items[1] / 1;
      }
    }
  }
}
