#!/usr/bin/perl
#use lib qw( /usr/local/rrdtool/lib/perl/5.8.0 );
#use RRDs;
use CGI qw/:standard/;

print "Content-type: text/html\r\n\r\n";

require "./config.pl";

$req_group=param("group");

$group_file="${top_dir}conf/grouplist.cfg";
open(FIN, $group_file);
@groups=<FIN>;

print"<link rel='stylesheet' href='oms.css' type='text/css'>";
print"<TABLE border=0 align=center width='950'>";
foreach $group (@groups) {

  @group_items=split(/ /, $group);
  $cpu_total=$group_items[2];
  if ($group_items[0] eq $req_group) {
#
# Initializing varaibles for this page
#
my(@cpu_pct_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-partition-overview-$group_items[0].gif",
            "--title=\"Consolidated CPU Utilization for $group_items[0]\"",
            "--vertical-label=\"CPU Utilization (%)\"",
            "--start=00:00",
            "--end=23:59",
            "--step=60",
            "--width=400",
            "--height=180",
            "--upper-limit=100",
            "--lower-limit=0",
            "--rigid"
          );
          
my(@cpu_cnt_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-cpu-cnt-partition-overview-$group_items[0].gif",
            "--title=\"CPU Allocation Statistics for $group_items[0]\"",
            "--vertical-label=\"Number of allocated CPUs\"",
            "--start=00:00",
            "--end=23:59",
            "--step=60",
            "--width=400",
            "--height=180",
            "--upper-limit=$cpu_total",
            "--lower-limit=0",            
            "--rigid"
          );
                    
$cnt=0;
$cpu_inuse=0;
$cpu_total_pct=0;
$partition_cpu_table="";
$partition_cpu_policy_table="";
$cpu_max_sum=0;
$cpu_min_sum=0;
$now = localtime time;

#
# Gathering the current CPU allocation status from the result of xlpstat for each PLM group
#
open(PLMIN, "< ${top_dir}tmp/xlpstat_$group_items[0]");
@lines=<PLMIN>;

@cpu_pct_graph_cmt_args=();
@cpu_cnt_graph_cmt_args=();
@title_args=();

foreach $line (@lines) {
  @items=split(/:/, $line);
  $cpu_inuse=$cpu_inuse+$items[4];
  $partition_name=$items[0];
  
  for($i=0; $i<10-length($items[0]);$i++) {
    $partition_name = " " . $partition_name;
  }
  
  push(@cpu_pct_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_total_pct.rrd:$items[0]:AVERAGE");
  push(@cpu_pct_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]:STACK ");  
  push(@cpu_pct_graph_cmt_args, "COMMENT:\"$partition_name  \"");  
  push(@cpu_pct_graph_cmt_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
  push(@cpu_pct_graph_cmt_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
  push(@cpu_pct_graph_cmt_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\\n\""); 
    
  push(@cpu_cnt_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_cpu_cur.rrd:$items[0]:AVERAGE");
  push(@cpu_cnt_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]:STACK ");
  push(@cpu_cnt_graph_cmt_args, "COMMENT:\"$partition_name  \"");  
  push(@cpu_cnt_graph_cmt_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
  push(@cpu_cnt_graph_cmt_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
  push(@cpu_cnt_graph_cmt_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\\n\""); 
    
  $cnt=$cnt+1;
  $cpu_pct = $items[5] * $items[4] / $cpu_total;
  $cpu_pct = int($cpu_pct*100)/100;
  $cpu_total_pct = $cpu_total_pct + $cpu_pct;
  
  get_cpu_load_high_low($group_items[1], $items[0]);     
  get_cpu_max_min($group_items[1], $items[0]);     
  
  $cpu_max_sum = $cpu_max_sum + $cpu_max;
  $cpu_min_sum = $cpu_min_sum + $cpu_min;
    
  $partition_cpu_table = $partition_cpu_table . "<tr><td width='20%'><div align='right'>";
  $partition_cpu_table = $partition_cpu_table . "<a href=./oms-cpu-partition-query.html?group=$group_items[0]&partition=$items[0]>" . $items[0] . "</a></div></td><td width=20%><div align=right>";
  $partition_cpu_table = $partition_cpu_table . $items[4] . "</div></td><td width=20%><div align=right>";
  $partition_cpu_table = $partition_cpu_table . $items[5] . "</div></td><td width=20%><div align=right>";
  $partition_cpu_table = $partition_cpu_table . $cpu_pct . "</div></td><td width=20%><div align=right>"; 
    
  if ($items[6] - $cpu_load_high > 0 && $cpu_load_high != 0) {
    $partition_cpu_table = $partition_cpu_table . "<font color=red>" . $items[6] . "</font></div></td></tr>";
  } else {
    $partition_cpu_table = $partition_cpu_table . $items[6] . "</div></td></tr>";
  }
  
  $partition_cpu_policy_table = $partition_cpu_policy_table . "<tr><td width='20%'><div align='right'>";
  $partition_cpu_policy_table = $partition_cpu_policy_table . $items[0] . "</div></td><td width=20%><div align=right>";
  $partition_cpu_policy_table = $partition_cpu_policy_table . $cpu_min . "</div></td><td width=20%><div align=right>";
  $partition_cpu_policy_table = $partition_cpu_policy_table . $cpu_max . "</div></td><td width=20%><div align=right>";
  $partition_cpu_policy_table = $partition_cpu_policy_table . $cpu_load_low . "</div></td><td width=20%><div align=right>"; 
  $partition_cpu_policy_table = $partition_cpu_policy_table . $cpu_load_high . "</div></td></tr>";

}
push(@title_args, "COMMENT:\"  \\n\"");    
push(@title_args, "COMMENT:\"---------------------------------------\\n\"");
push(@title_args, "COMMENT:\"              Maximum  Minimum  Average\\n\"");
  
$cpu_inuse_pct=100*$cpu_inuse/$group_items[2];
$cpu_free=$group_items[2]-$cpu_inuse;
$cpu_free_pct=100-$cpu_inuse_pct;

#
# Generating CPU utilization graph for each PLM group
#
#RRDs::graph @rrd_graph_args; 
system "rrdtool graph @cpu_pct_graph_args @title_args @cpu_pct_graph_cmt_args 1>/dev/null";
system "rrdtool graph @cpu_cnt_graph_args @title_args @cpu_cnt_graph_cmt_args 1>/dev/null";

print <<HTMLEND;
  <tr> 
    <td align=left colspan="2">
      <table width="100%" cellpadding="2" cellspacing="2" bgcolor="#000000">
        <tr> 
          <td BGCOLOR="#000000"><font color="white">$group_items[0]</font></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr> 
    <td valign=top align=center width="560">
      <img src=${htdocs_dir}oms/images/oms-cpu-cnt-partition-overview-$group_items[0].gif><br><br>
      <img src=${htdocs_dir}oms/images/oms-cpu-partition-overview-$group_items[0].gif>
    </td>
    <td valign=top align=left> 
      <table width="95%" cellpadding="2" cellspacing="2" bgcolor="#000000">
        <tr> 
          <td BGCOLOR="#000000"><font color="white">Total CPU Resource Status</font></td>
          <td BGCOLOR="#000000" align=right><a href="./oms-cpu-all-partitions-query.html?group=$group_items[0]"><font color="white">Detail</font></a></td>
        </tr>
      </table>
      <TABLE class="oms" width="95%">
        <TR bgcolor="#666666"> 
          <TD width="33%"> 
            <div align="center"><b><font color="#FFFFFF">&nbsp;</font></b></div>
          </TD>
          <TD> 
            <div align="center"><b><font color="#FFFFFF"># of CPU</font></b></div>
          </TD>
          <TD width="33%"> 
            <div align="center"><b><font color="#FFFFFF">%</font></b></div>
          </TD>
        </TR>
        <TR> 
          <TD width="33%"> 
            <div align="center">In Use</div>
          </TD>
          <TD> 
            <div align="right">$cpu_inuse</div>
          </TD>
          <TD width="33%"> 
            <div align="right">$cpu_inuse_pct</div>
          </TD>
        </TR>
        <TR> 
          <TD width="33%"> 
            <div align="center">Free Pool</div>
          </TD>
          <TD> 
            <div align="right">$cpu_free</div>
          </TD>
          <TD width="33%"> 
            <div align="right">$cpu_free_pct</div>
          </TD>
        </TR>		
        <TR> 
          <TD width="33%"> 
            <div align="center">Total</div>
          </TD>
          <TD> 
            <div align="right">$cpu_total</div>
          </TD>
          <TD width="33%"> 
            <div align="right">&nbsp;</div>
          </TD>
        </TR>		
      </TABLE>
<br>  
<table width="95%" cellpadding="2" cellspacing="2">
  <tr> 
    <td bgcolor="#000000"><font color="white">CPU Status per partition</font></td>
  </tr>
</table>

<table class="oms" width="95%" cellpadding="2" cellspacing="2">
  <tr bgcolor="#999999"> 
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Partition</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF"># of CPU</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Util %</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Util %<br>(Total)</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">CPU Load</font></div>
    </td>
  </tr>
  $partition_cpu_table
  <tr bgcolor="#999999"> 
    <td colspan="3"> 
      <div align="right"><font color="#FFFFFF">CPU Utilization (Total)</font></div>
    </td>
    <td> 
      <div align="right"><font color="#FFFFFF">$cpu_total_pct</font></div>
    </td>
    <td> 
      &nbsp;
    </td>
  </tr>  
</table>
<br>            
<table width="95%" cellpadding="2" cellspacing="2">
  <tr> 
    <td bgcolor="#000000"><font color="white">PLM Policy for CPU</font></td>
  </tr>
</table>

<table class="oms" width="95%" cellpadding="2" cellspacing="2">
  <tr bgcolor="#999999"> 
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Partition</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Min</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Max</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Load<br>low</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Load<br>high</font></div>
    </td>
  </tr>
  $partition_cpu_policy_table
  <tr bgcolor="#999999"> 
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Sum</font></div>
    </td>
    <td width="20%"> 
      <div align="right"><font color="#FFFFFF">$cpu_min_sum</font></div>
    </td>
    <td width="20%"> 
      <div align="right"><font color="#FFFFFF">$cpu_max_sum</font></div>
    </td>
    <td width="20%"> 
      <div align="center">&nbsp;</div>
    </td>
    <td width="20%"> 
      <div align="center">&nbsp;</div>
    </td>
  </tr>
</table>            
    </td>
  </tr>
HTMLEND
  }
}
print "</table>";
