#!/usr/bin/perl
#use lib qw( /usr/local/rrdtool/lib/perl/5.8.0 );
#use RRDs;
use CGI qw/:standard/;

print "Content-type: text/html\r\n\r\n";

require "./config.pl";

$req_group=param("group");

$group_file="${top_dir}conf/grouplist.cfg";
open(FIN, $group_file);
@groups=<FIN>;

print"<link rel='stylesheet' href='oms.css' type='text/css'>";
print"<TABLE border=0 align=center width='950'>";
foreach $group (@groups) {

  @group_items=split(/ /, $group);
  $mem_total=$group_items[3];

  if ($group_items[0] eq $req_group) {
#
# Initializing varaibles for this page
#
my(@mem_pct_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-mem-partition-overview-$group_items[0].gif",
            "--title=\"Consolidated Memory Utilization for $group_items[0]\"",
            "--vertical-label=\"Memory Utilization (%)\"",
            "--start=00:00",
            "--end=23:59",
            "--step=60",
            "--width=400",
            "--height=180",
            "--upper-limit=100",
            "--lower-limit=0",
            "--rigid"
          );
          
my(@mem_cnt_graph_args) = (
            "${top_dir}htdocs${htdocs_dir}oms/images/oms-mem-cnt-partition-overview-$group_items[0].gif",
            "--title=\"Memory Allocation Statistics for $group_items[0]\"",
            "--vertical-label=\"MBs of allocated Memory\"",
            "--start=00:00",
            "--end=23:59",
            "--step=60",
            "--width=400",
            "--height=180",
            "--upper-limit=$mem_total",
            "--lower-limit=0",            
            "--rigid"
          );
                    
$cnt=0;
$mem_inuse=0;
$mem_total_pct=0;
$partition_mem_table="";
$partition_mem_policy_table="";
$mem_max_sum=0;
$mem_min_sum=0;
$now = localtime time;

#
# Gathering the current Memory allocation status from the result of xlpstat for each PLM group
#

open(PLMIN, "< ${top_dir}tmp/xlpstat_$group_items[0]");
@lines=<PLMIN>;

@mem_pct_graph_cmt_args=();
@mem_cnt_graph_cmt_args=();
@title_args=();

foreach $line (@lines) {
  @items=split(/:/, $line);
  $mem_inuse=$mem_inuse+$items[7];
  $partition_name=$items[0];
  
  for($i=0; $i<10-length($items[0]);$i++) {
    $partition_name = " " . $partition_name;
  }
  
  push(@mem_pct_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_mem_total_pct.rrd:$items[0]:AVERAGE");
  push(@mem_pct_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]:STACK ");  
  push(@mem_pct_graph_cmt_args, "COMMENT:\"$partition_name  \"");  
  push(@mem_pct_graph_cmt_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
  push(@mem_pct_graph_cmt_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
  push(@mem_pct_graph_cmt_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\\n\""); 
    
  push(@mem_cnt_graph_args, "DEF:$items[0]=${top_dir}data/$group_items[0]_mem_cur.rrd:$items[0]:AVERAGE");
  push(@mem_cnt_graph_args, "AREA:$items[0]$colors[$cnt]:$items[0]:STACK ");
  push(@mem_cnt_graph_cmt_args, "COMMENT:\"$partition_name  \"");  
  push(@mem_cnt_graph_cmt_args, "GPRINT:$items[0]:MAX:\"%7.2lf\"");
  push(@mem_cnt_graph_cmt_args, "GPRINT:$items[0]:MIN:\"%6.2lf\"");
  push(@mem_cnt_graph_cmt_args, "GPRINT:$items[0]:AVERAGE:\"%6.2lf\\n\""); 
    
  $cnt=$cnt+1;

  $mem_pct = $items[7] * $items[8] / $mem_total;
  $mem_pct = int($mem_pct*100)/100;
  $mem_total_pct = $mem_total_pct + $mem_pct;
  $mem_free = int(((100.0-$items[8])/100.0)*$items[7]);
  
  get_mem_util_high_low($group_items[1], $items[0]);     
  get_mem_max_min($group_items[1], $items[0]);     
  
  $mem_max_sum = $mem_max_sum + $mem_max;
  $mem_min_sum = $mem_min_sum + $mem_min;
    
  $partition_mem_table = $partition_mem_table . "<tr><td width='20%'><div align='right'>";
  $partition_mem_table = $partition_mem_table . "<a href=./oms-mem-partition-query.html?group=$group_items[0]&partition=$items[0]>" . $items[0] . "</a></div></td><td width=20%><div align=right>";
  $partition_mem_table = $partition_mem_table . $items[7] . "</div></td><td width=20%><div align=right>";
  $partition_mem_table = $partition_mem_table . $items[8] . "</div></td><td width=20%><div align=right>";
  $partition_mem_table = $partition_mem_table . $mem_pct . "</div></td><td width=20%><div align=right>"; 
    
  if ($items[6] - $mem_util_high > 0 && $mem_util_high != 0) {
    $partition_mem_table = $partition_mem_table . "<font color=red>" . $mem_free . "</font></div></td></tr>";
  } else {
    $partition_mem_table = $partition_mem_table . $mem_free . "</div></td></tr>";
  }
  
  $partition_mem_policy_table = $partition_mem_policy_table . "<tr><td width='20%'><div align='right'>";
  $partition_mem_policy_table = $partition_mem_policy_table . $items[0] . "</div></td><td width=20%><div align=right>";
  $partition_mem_policy_table = $partition_mem_policy_table . $mem_min . "</div></td><td width=20%><div align=right>";
  $partition_mem_policy_table = $partition_mem_policy_table . $mem_max . "</div></td><td width=20%><div align=right>";
  $partition_mem_policy_table = $partition_mem_policy_table . $mem_util_low . "</div></td><td width=20%><div align=right>"; 
  $partition_mem_policy_table = $partition_mem_policy_table . $mem_util_high . "</div></td></tr>";

}
push(@title_args, "COMMENT:\"  \\n\"");    
push(@title_args, "COMMENT:\"---------------------------------------\\n\"");
push(@title_args, "COMMENT:\"              Maximum  Minimum  Average\\n\"");
  
# DLF $mem_inuse_pct=100*$mem_inuse/$group_items[3];
# DLF $mem_free=$group_items[2]-$mem_inuse;
# DLF $mem_free_pct=100-$mem_inuse_pct;

$mem_inuse_pct=int(($mem_inuse/$group_items[3])*100);
$mem_free=$group_items[3]-$mem_inuse;
$mem_free_pct=int((($group_items[3]-$mem_inuse)/$group_items[3])*100);

#
# Generating Memory utilization graph for each PLM group
#
#RRDs::graph @rrd_graph_args; 
system "rrdtool graph @mem_pct_graph_args @title_args @mem_pct_graph_cmt_args 1>/dev/null";
system "rrdtool graph @mem_cnt_graph_args @title_args @mem_cnt_graph_cmt_args 1>/dev/null";

print <<HTMLEND;
  <tr> 
    <td align=left colspan="2">
      <table width="100%" cellpadding="2" cellspacing="2" bgcolor="#000000">
        <tr> 
          <td BGCOLOR="#000000"><font color="white">$group_items[0]</font></td>
        </tr>
      </table>
    </td>
  </tr>
  <tr> 
    <td valign=top align=center width="560">
      <img src=${htdocs_dir}oms/images/oms-mem-cnt-partition-overview-$group_items[0].gif><br><br>
      <img src=${htdocs_dir}oms/images/oms-mem-partition-overview-$group_items[0].gif>
    </td>
    <td valign=top align=left> 
      <table width="95%" cellpadding="2" cellspacing="2" bgcolor="#000000">
        <tr> 
          <td BGCOLOR="#000000"><font color="white">Total Memory Resource Status</font></td>
          <td BGCOLOR="#000000" align=right><a href="./oms-mem-all-partitions-query.html?group=$group_items[0]"><font color="white">Detail</font></a></td>
        </tr>
      </table>
      <TABLE class="oms" width="95%">
        <TR bgcolor="#666666"> 
          <TD width="33%"> 
            <div align="center"><b><font color="#FFFFFF">&nbsp;</font></b></div>
          </TD>
          <TD> 
            <div align="center"><b><font color="#FFFFFF">MB of Memory</font></b></div>
          </TD>
          <TD width="33%"> 
            <div align="center"><b><font color="#FFFFFF">%</font></b></div>
          </TD>
        </TR>
        <TR> 
          <TD width="33%"> 
            <div align="center">In Use</div>
          </TD>
          <TD> 
            <div align="right">$mem_inuse</div>
          </TD>
          <TD width="33%"> 
            <div align="right">$mem_inuse_pct</div>
          </TD>
        </TR>
        <TR> 
          <TD width="33%"> 
            <div align="center">Free Pool</div>
          </TD>
          <TD> 
            <div align="right">$mem_free</div>
          </TD>
          <TD width="33%"> 
            <div align="right">$mem_free_pct</div>
          </TD>
        </TR>		
        <TR> 
          <TD width="33%"> 
            <div align="center">Total</div>
          </TD>
          <TD> 
            <div align="right">$mem_total</div>
          </TD>
          <TD width="33%"> 
            <div align="right">&nbsp;</div>
          </TD>
        </TR>		
      </TABLE>
<br>  
<table width="95%" cellpadding="2" cellspacing="2">
  <tr> 
    <td bgcolor="#000000"><font color="white">Memory Status per partition</font></td>
  </tr>
</table>

<table class="oms" width="95%" cellpadding="2" cellspacing="2">
  <tr bgcolor="#999999"> 
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Partition</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">MB of Memory</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Util %</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Util %<br>(Total)</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">MB Free</font></div>
    </td>
  </tr>
  $partition_mem_table
  <tr bgcolor="#999999"> 
    <td colspan="3"> 
      <div align="right"><font color="#FFFFFF">Memory Utilization (Total)</font></div>
    </td>
    <td> 
      <div align="right"><font color="#FFFFFF">$mem_total_pct</font></div>
    </td>
    <td> 
      &nbsp;
    </td>
  </tr>  
</table>
<br>            
<table width="95%" cellpadding="2" cellspacing="2">
  <tr> 
    <td bgcolor="#000000"><font color="white">PLM Policy for Memory</font></td>
  </tr>
</table>

<table class="oms" width="95%" cellpadding="2" cellspacing="2">
  <tr bgcolor="#999999"> 
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Partition</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Min</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Max</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Load<br>low</font></div>
    </td>
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Load<br>high</font></div>
    </td>
  </tr>
  $partition_mem_policy_table
  <tr bgcolor="#999999"> 
    <td width="20%"> 
      <div align="center"><font color="#FFFFFF">Sum</font></div>
    </td>
    <td width="20%"> 
      <div align="right"><font color="#FFFFFF">$mem_min_sum</font></div>
    </td>
    <td width="20%"> 
      <div align="right"><font color="#FFFFFF">$mem_max_sum</font></div>
    </td>
    <td width="20%"> 
      <div align="center">&nbsp;</div>
    </td>
    <td width="20%"> 
      <div align="center">&nbsp;</div>
    </td>
  </tr>
</table>            
    </td>
  </tr>
HTMLEND
  }
}
print "</table>";
