#!/usr/bin/perl
#

$group_file='/usr/local/omsEnhanced/conf/grouplist.cfg';
open(FIN, $group_file);
@groups=<FIN>;

foreach $group (@groups) 
{
  @group_items=split(/ /, $group);
  
  # Fetch resource usage data for each LPAR using xlpstat command
  system("/usr/sbin/xlpstat -r -p /etc/plm/policies/$group_items[1]|grep -v ^# > /usr/local/omsEnhanced/data/current.data");
  system("/usr/bin/cp /usr/local/omsEnhanced/data/current.data /usr/local/omsEnhanced/tmp/xlpstat_$group_items[0]");

  $total_cpu = $group_items[2];
  $total_mem = $group_items[3];
  
  $file = "/usr/local/omsEnhanced/tmp/xlpstat_$group_items[0]";
  open(PLM, $file);
  @lpars = <PLM>;

  $cpu_cur_cmd = "/usr/bin/rrdtool update /usr/local/omsEnhanced/data/$group_items[0]_cpu_cur.rrd N";
  $cpu_pct_cmd = "/usr/bin/rrdtool update /usr/local/omsEnhanced/data/$group_items[0]_cpu_pct.rrd N";
  $cpu_total_pct_cmd = "/usr/bin/rrdtool update /usr/local/omsEnhanced/data/$group_items[0]_cpu_total_pct.rrd N";
  $cpu_load_cmd = "/usr/bin/rrdtool update /usr/local/omsEnhanced/data/$group_items[0]_cpu_load.rrd N";  
  
  $mem_cur_cmd = "/usr/bin/rrdtool update /usr/local/omsEnhanced/data/$group_items[0]_mem_cur.rrd N";
  $mem_pct_cmd = "/usr/bin/rrdtool update /usr/local/omsEnhanced/data/$group_items[0]_mem_pct.rrd N";
  $mem_total_pct_cmd = "/usr/bin/rrdtool update /usr/local/omsEnhanced/data/$group_items[0]_mem_total_pct.rrd N";
  
  foreach $lpar (@lpars)
  {
    print($lpar."\n");
    @items = split(/:/,$lpar);
    $cpu_pct = @items[5] * @items[4] / $total_cpu;
  
    $cpu_cur_cmd        = $cpu_cur_cmd . ":" . @items[4];
    $cpu_pct_cmd        = $cpu_pct_cmd . ":" . @items[5];
    $cpu_total_pct_cmd  = $cpu_total_pct_cmd . ":" . $cpu_pct;
    $cpu_load_cmd       = $cpu_load_cmd . ":" . @items[6];   

    $mem_pct = @items[7] * @items[8] / $total_mem;
    $mem_cur_cmd        = $mem_cur_cmd . ":" . @items[7];
    $mem_pct_cmd        = $mem_pct_cmd . ":" . @items[8];
    $mem_total_pct_cmd  = $mem_total_pct_cmd . ":" . $mem_pct;

  }
  
  print("$group_items[0] $cpu_cur_cmd\n");
  system($cpu_cur_cmd);
  print("$group_items[0] $cpu_pct_cmd\n");
  system($cpu_pct_cmd);
  print("$group_items[0] $cpu_total_pct_cmd\n");
  system($cpu_total_pct_cmd);
  print("$group_items[0] $cpu_load_cmd\n");
  system($cpu_load_cmd); 


  print("$group_items[0] $mem_cur_cmd\n");
  system($mem_cur_cmd);
  print("$group_items[0] $mem_pct_cmd\n");
  system($mem_pct_cmd);
  print("$group_items[0] $mem_total_pct_cmd\n");
  system($mem_total_pct_cmd);
  print("$group_items[0] $mem_util_cmd\n");
  system($mem_util_cmd); 

  print "Updating done... $group_items[1]\n";
  close(PLM);
} 

close(FIN);
